#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <termios.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define SERIAL_PORT     "/dev/ttyAM1"

int main(){
  int fd;
  fd = open(SERIAL_PORT, O_RDWR | O_NOCTTY);
  if(fd < 0){
    printf("%s doesn't open it\n",SERIAL_PORT);
    return -1;
  }

  struct termios oldtio, newtio;
  tcgetattr(fd, &oldtio);
  newtio = oldtio;

  newtio.c_iflag = (IGNPAR | ICRNL);
  cfsetspeed(&newtio, B9600);

  /* {[h̐ݒ */
  int id=120;

  int uWait=25000;
  int retry=10;

  int i, j, k;
  unsigned char command[4] = {255, id, 1, 1};
  unsigned char data[20];
  
  for(i=1 ; i<=10 ; i++){
    printf("Getting data : %d\n", i);

    /* f[^Mv */
    write(fd, command, sizeof(command));
    for(j=0 ; j<retry ; j++){
      usleep(uWait);
      read(fd, data, sizeof(data));
      /* data check */
      if(data[0] == 255 && data[1] == id && data[2] == 17 && data[3] == 1){
        printf("Retry number: %d\n", j);
        for(k=4 ; k<20 ; k++){
          printf("port%2d : data=%d\n", j-3, data[j]);
        }
      }
    }
  }

  tcsetattr(fd, TCSANOW, &oldtio);
  close(fd);
  return 0;
}
